Index: issm/trunk/src/c/classes/Elements/Seg.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Seg.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Seg.h	(revision 18301)
@@ -55,10 +55,9 @@
 		void        ComputeBasalStress(Vector<IssmDouble>* sigma_b){_error_("not implemented yet");};
 		void        ComputeSigmaNN(){_error_("not implemented yet");};
-		void        ComputeStrainRate(){_error_("not implemented yet");};
-		void        ComputeStrainRate(Vector<IssmDouble>* eps){_error_("not implemented yet");};
 		void        ComputeStressTensor(){_error_("not implemented yet");};
 		void        ComputeDeviatoricStressTensor(){_error_("not implemented yet");};
 		void        Configure(Elements* elements,Loads* loads,Nodes* nodesin,Vertices* verticesin,Materials* materials,Parameters* parameters){_error_("not implemented yet");};
 		void        SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Materials* materials,Parameters* parameters){_error_("not implemented yet");};
+		void        ResetHooks(){_error_("not implemented yet");};
 		void        Delta18oParameterization(void){_error_("not implemented yet");};
 		void        ElementSizes(IssmDouble* hx,IssmDouble* hy,IssmDouble* hz){_error_("not implemented yet");};
@@ -69,4 +68,5 @@
 		int         GetNodeIndex(Node* node){_error_("not implemented yet");};
 		int         GetNumberOfNodes(void);
+		int         GetNumberOfNodes(int enum_type){_error_("not implemented yet");};
 		int         GetNumberOfVertices(void);
 		void        GetVerticesCoordinates(IssmDouble** pxyz_list);
@@ -83,5 +83,6 @@
 		IssmDouble  MinEdgeLength(IssmDouble* xyz_list){_error_("not implemented yet");};
 		void        NodalFunctions(IssmDouble* basis,Gauss* gauss);
-		void        NodalFunctionsP1(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
+		void        NodalFunctionsP1(IssmDouble* basis,Gauss* gauss);
+		void        NodalFunctionsP2(IssmDouble* basis,Gauss* gauss);
 		void        NodalFunctionsVelocity(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
 		void        NodalFunctionsPressure(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
@@ -122,7 +123,8 @@
 		bool        IsZeroLevelset(int levelset_enum){_error_("not implemented");};
 		bool		   IsIcefront(void);
-		bool   IsFaceOnBoundary(void){_error_("not implemented yet");};
+		bool        IsFaceOnBoundary(void){_error_("not implemented yet");};
 		void        ZeroLevelsetCoordinates(IssmDouble** pxyz_zero,IssmDouble* xyz_list,int levelsetenum){_error_("not implemented");};
 		void		   GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum);
+		void		   GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level){_error_("not implemented");};
 
 		void        GetSolutionFromInputsOneDof(Vector<IssmDouble>* solution,int enum_type){_error_("not implemented yet");};
@@ -136,5 +138,4 @@
 		void        ReduceMatrices(ElementMatrix* Ke,ElementVector* pe){_error_("not implemented yet");};
 		void        SetTemporaryElementType(int element_type_in){_error_("not implemented yet");};
-		void	      SmbGradients(){_error_("not implemented yet");};
 		IssmDouble  SurfaceArea(void){_error_("not implemented yet");};
 		void        Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type,int finitelement){_error_("not implemented yet");};
@@ -147,18 +148,7 @@
 		IssmDouble IceVolumeAboveFloatation(void){_error_("not implemented yet");};
 		IssmDouble TotalSmb(void){_error_("not implemented yet");};
-		void       MinVel(IssmDouble* pminvel){_error_("not implemented yet");};
-		void       MinVx(IssmDouble* pminvx){_error_("not implemented yet");};
-		void       MinVy(IssmDouble* pminvy){_error_("not implemented yet");};
-		void       MinVz(IssmDouble* pminvz){_error_("not implemented yet");};
 		IssmDouble MassFlux(IssmDouble* segment){_error_("not implemented yet");};
 		IssmDouble MassFlux(IssmDouble x1,IssmDouble y1, IssmDouble x2, IssmDouble y2,int segment_id){_error_("not implemented yet");}
-		void       MaxAbsVx(IssmDouble* pmaxabsvx){_error_("not implemented yet");};
-		void       MaxAbsVy(IssmDouble* pmaxabsvy){_error_("not implemented yet");};
-		void       MaxAbsVz(IssmDouble* pmaxabsvz){_error_("not implemented yet");};
 		void       ElementResponse(IssmDouble* presponse,int response_enum){_error_("not implemented yet");};
-		void       MaxVel(IssmDouble* pmaxvel){_error_("not implemented yet");};
-		void       MaxVx(IssmDouble* pmaxvx){_error_("not implemented yet");};
-		void       MaxVy(IssmDouble* pmaxvy){_error_("not implemented yet");};
-		void       MaxVz(IssmDouble* pmaxvz){_error_("not implemented yet");};
 		IssmDouble Misfit(int modelenum,int observationenum,int weightsenum){_error_("not implemented yet");};
 		IssmDouble MisfitArea(int weightsenum){_error_("not implemented yet");};
@@ -168,21 +158,6 @@
 #endif
 
-		void       GradientIndexing(int* indexing,int control_index);
-		void       Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index){_error_("not implemented yet");};
-		void       GradjBGradient(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDGradient(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjBSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDragSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDragFS(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDragGradient(Vector<IssmDouble>* gradient,int control_index);
-		void       GradjDhDtBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjVxBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjVyBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjThicknessBalancethicknessSoft(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
 		void       GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data){_error_("not implemented yet");};
 		void       SetControlInputsFromVector(IssmDouble* vector,int control_enum,int control_index){_error_("not implemented yet");};
-		void       ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){_error_("not implemented yet");};
-		void       ControlInputScaleGradient(int enum_type,IssmDouble scale){_error_("not implemented yet");};
 		void       ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){_error_("not implemented yet");};
 		void       ControlToVectors(Vector<IssmPDouble>* vector_control, Vector<IssmPDouble>* vector_gradient,int control_enum){_error_("not implemented yet");};
Index: issm/trunk/src/c/classes/Elements/SegRef.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/SegRef.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/SegRef.cpp	(revision 18301)
@@ -21,36 +21,11 @@
 /*Object constructors and destructor*/
 SegRef::SegRef(){/*{{{*/
-	this->element_type_list=NULL;
-}
-/*}}}*/
-SegRef::SegRef(const int nummodels){/*{{{*/
-
-	/*Only allocate pointer*/
-	element_type_list=xNew<int>(nummodels);
-
 }
 /*}}}*/
 SegRef::~SegRef(){/*{{{*/
-	xDelete<int>(element_type_list);
-}
-/*}}}*/
-
-/*Management*/
-void SegRef::SetElementType(int type,int type_counter){/*{{{*/
-
-	/*initialize element type*/
-	this->element_type_list[type_counter]=type;
 }
 /*}}}*/
 
 /*Reference Element numerics*/
-void SegRef::GetNodalFunctions(IssmDouble* basis,GaussSeg* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions  at the gaussian point.*/
-
-	_assert_(basis);
-
-	GetNodalFunctions(basis,gauss,this->element_type);
-}
-/*}}}*/
 void SegRef::GetNodalFunctions(IssmDouble* basis,GaussSeg* gauss,int finiteelement){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
@@ -74,10 +49,4 @@
 			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
-}
-/*}}}*/
-void SegRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussSeg* gauss){/*{{{*/
-
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,this->element_type);
-
 }
 /*}}}*/
@@ -107,12 +76,4 @@
 	/*Clean up*/
 	xDelete<IssmDouble>(dbasis_ref);
-
-}
-/*}}}*/
-void SegRef::GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussSeg* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * natural coordinate system) at the gaussian point. */
-
-	GetNodalFunctionsDerivativesReference(dbasis,gauss,this->element_type);
 
 }
@@ -147,5 +108,5 @@
 }
 /*}}}*/
-void SegRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussSeg* gauss){/*{{{*/
+void SegRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussSeg* gauss,int finiteelement){/*{{{*/
 
 	/*From node values of parameter p (plist[0],plist[1]), return parameter derivative value at gaussian 
@@ -160,9 +121,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions derivatives*/
 	IssmDouble* dbasis=xNew<IssmDouble>(1*numnodes);
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss);
+	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,finiteelement);
 
 	/*Calculate parameter for this Gauss point*/
@@ -175,9 +136,4 @@
 }
 /*}}}*/
-void SegRef::GetInputValue(IssmDouble* p, IssmDouble* plist, GaussSeg* gauss){/*{{{*/
-
-	GetInputValue(p,plist,gauss,this->element_type);
-}
-/*}}}*/
 void SegRef::GetInputValue(IssmDouble* p, IssmDouble* plist, GaussSeg* gauss,int finiteelement){/*{{{*/
 
@@ -230,9 +186,4 @@
 	/*Invert Jacobian matrix: */
 	*Jinv = 1./J;
-}
-/*}}}*/
-int  SegRef::NumberofNodes(void){/*{{{*/
-
-	return this->NumberofNodes(this->element_type);
 }
 /*}}}*/
@@ -243,5 +194,5 @@
 		case P1Enum:                return NUMNODESP1;
 		case P1DGEnum:              return NUMNODESP1;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		default: _error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
Index: issm/trunk/src/c/classes/Elements/SegRef.h
===================================================================
--- issm/trunk/src/c/classes/Elements/SegRef.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/SegRef.h	(revision 18301)
@@ -13,27 +13,15 @@
 
 	public: 
-		int* element_type_list;
-		int  element_type;
-
 		SegRef();
-		SegRef(const int nummodels);
 		~SegRef();
 
-		/*Management*/
-		void SetElementType(int type,int type_counter);
 		void GetJacobian(IssmDouble* J, IssmDouble* xyz_list,GaussSeg* gauss);
 		void GetJacobianDeterminant(IssmDouble*  Jdet, IssmDouble* xyz_list,GaussSeg* gauss);
 		void GetJacobianInvert(IssmDouble* Jinv, IssmDouble* xyz_list,GaussSeg* gauss);
-		void GetNodalFunctions(IssmDouble* basis,GaussSeg* gauss);
 		void GetNodalFunctions(IssmDouble* basis,GaussSeg* gauss,int finiteelement);
-		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussSeg* gauss);
 		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussSeg* gauss,int finiteelement);
-		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussSeg* gauss);
 		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussSeg* gauss,int finiteelement);
-		void GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussSeg* gauss);
-		void GetInputValue(IssmDouble* p, IssmDouble* plist, GaussSeg* gauss);
+		void GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussSeg* gauss,int finiteelement);
 		void GetInputValue(IssmDouble* p, IssmDouble* plist, GaussSeg* gauss,int finiteelement);
-
-		int  NumberofNodes(void);
 		int  NumberofNodes(int finiteelement);
 };
Index: issm/trunk/src/c/classes/Elements/Tetra.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tetra.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Tetra.cpp	(revision 18301)
@@ -21,5 +21,5 @@
 /*Constructors/destructor/copy*/
 Tetra::Tetra(int seg_id, int seg_sid, int index, IoModel* iomodel,int nummodels)/*{{{*/
-		:TetraRef(nummodels),ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
+		:ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
 
 			/*id: */
@@ -38,4 +38,7 @@
 			this->material = NULL;
 			this->matpar   = NULL;
+
+			/*Only allocate pointer*/
+			this->element_type_list=xNew<int>(nummodels);
 		}
 /*}}}*/
@@ -45,5 +48,57 @@
 /*}}}*/
 Object* Tetra::copy() {/*{{{*/
-	_error_("not implemented yet");
+
+	int i;
+	Tetra* tetra=NULL;
+
+	tetra=new Tetra();
+
+	//deal with TetraRef mother class
+	int nanalyses = this->numanalyses;
+	if(nanalyses > 0){
+		tetra->element_type_list=xNew<int>(nanalyses);
+		for(i=0;i<nanalyses;i++){
+			if (this->element_type_list[i]) tetra->element_type_list[i]=this->element_type_list[i];
+			else tetra->element_type_list[i] = 0;
+		}
+	}
+	else tetra->element_type_list = NULL;
+	tetra->element_type=this->element_type;
+	tetra->numanalyses=nanalyses;
+
+	//deal with ElementHook mother class
+	if (this->hnodes){
+		tetra->hnodes=xNew<Hook*>(tetra->numanalyses);
+		for(i=0;i<tetra->numanalyses;i++){
+			if (this->hnodes[i]) tetra->hnodes[i] = (Hook*)(this->hnodes[i]->copy());
+			else tetra->hnodes[i] = NULL;
+		}
+	}
+	else tetra->hnodes = NULL;
+
+	tetra->hvertices = (Hook*)this->hvertices->copy();
+	tetra->hmaterial = (Hook*)this->hmaterial->copy();
+	tetra->hmatpar   = (Hook*)this->hmatpar->copy();
+	tetra->hneighbors = NULL;
+
+	/*deal with Tria fields: */
+	tetra->id  = this->id;
+	tetra->sid = this->sid;
+	if(this->inputs) tetra->inputs = (Inputs*)(this->inputs->Copy());
+	else tetra->inputs=new Inputs();
+
+	/*point parameters: */
+	tetra->parameters=this->parameters;
+
+	/*recover objects: */
+	unsigned int num_nodes = 3;
+	tetra->nodes = xNew<Node*>(num_nodes); //we cannot rely on an analysis_counter to tell us which analysis_type we are running, so we just copy the nodes.
+	for(i=0;i<num_nodes;i++) if(this->nodes[i]) tetra->nodes[i]=this->nodes[i]; else tetra->nodes[i] = NULL;
+
+	tetra->vertices = (Vertex**)this->hvertices->deliverp();
+	tetra->material = (Material*)this->hmaterial->delivers();
+	tetra->matpar   = (Matpar*)this->hmatpar->delivers();
+
+	return tetra;
 }
 /*}}}*/
@@ -202,5 +257,5 @@
 
 	_assert_(nodes);
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	for(int i=0;i<numnodes;i++){
@@ -212,5 +267,5 @@
 /*}}}*/
 int      Tetra::GetNumberOfNodes(void){/*{{{*/
-	return this->NumberofNodes();
+	return this->NumberofNodes(this->element_type);
 }
 /*}}}*/
@@ -400,5 +455,5 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	/*Fetch dof list and allocate solution vector*/
@@ -502,5 +557,5 @@
 
 	_assert_(gauss->Enum()==GaussTetraEnum);
-	this->GetNodalFunctions(basis,(GaussTetra*)gauss);
+	this->GetNodalFunctions(basis,(GaussTetra*)gauss,this->element_type);
 
 }
@@ -530,5 +585,5 @@
 
 	_assert_(gauss->Enum()==GaussTetraEnum);
-	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussTetra*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussTetra*)gauss,this->element_type);
 
 }
@@ -661,5 +716,5 @@
 	/*For FS only: we want the CS to be tangential to the bedrock*/
 	inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(IsFloating() || !HasNodeOnBase() ||  approximation!=FSApproximationEnum) return;
+	if(!HasNodeOnBase() ||  approximation!=FSApproximationEnum) return;
 
 	//printf("element number %i \n",this->id);
@@ -724,4 +779,20 @@
 }
 /*}}}*/
+void     Tetra::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->vertices=NULL;
+	this->material=NULL;
+	this->matpar=NULL;
+	this->parameters=NULL;
+
+	//deal with ElementHook mother class
+	for(int i=0;i<this->numanalyses;i++) if(this->hnodes[i]) this->hnodes[i]->reset();
+	this->hvertices->reset();
+	this->hmaterial->reset();
+	this->hmatpar->reset();
+	if(this->hneighbors) this->hneighbors->reset();
+}
+/*}}}*/
 Element* Tetra::SpawnBasalElement(void){/*{{{*/
 
@@ -788,5 +859,5 @@
 
 	/*Recover element type*/
-	this->SetElementType(finiteelement_type,analysis_counter);
+	this->element_type_list[analysis_counter]=finiteelement_type;
 
 	/*Recover vertices ids needed to initialize inputs*/
@@ -841,4 +912,5 @@
 			break;
 		case TaylorHoodEnum:
+		case XTaylorHoodEnum:
 			numnodes        = 14;
 			tetra_node_ids  = xNew<int>(numnodes);
@@ -859,4 +931,18 @@
 			tetra_node_ids[13]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elements[4*index+3];
 			break;
+		case LATaylorHoodEnum:
+			numnodes        = 10;
+			tetra_node_ids  = xNew<int>(numnodes);
+			tetra_node_ids[0]=iomodel->nodecounter+iomodel->elements[4*index+0];
+			tetra_node_ids[1]=iomodel->nodecounter+iomodel->elements[4*index+1];
+			tetra_node_ids[2]=iomodel->nodecounter+iomodel->elements[4*index+2];
+			tetra_node_ids[3]=iomodel->nodecounter+iomodel->elements[4*index+3];
+			tetra_node_ids[4]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+0]+1;
+			tetra_node_ids[5]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+1]+1;
+			tetra_node_ids[6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+2]+1;
+			tetra_node_ids[7]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+3]+1;
+			tetra_node_ids[8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+4]+1;
+			tetra_node_ids[9]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[6*index+5]+1;
+			break;
 		default:
 			_error_("Finite element "<<EnumToStringx(finiteelement_type)<<" not supported yet");
@@ -871,6 +957,10 @@
 }
 /*}}}*/
+void     Tetra::ValueP1OnGauss(IssmDouble* pvalue,IssmDouble* values,Gauss* gauss){/*{{{*/
+	TetraRef::GetInputValue(pvalue,values,gauss,P1Enum);
+}
+/*}}}*/
 int      Tetra::VelocityInterpolation(void){/*{{{*/
-	return TetraRef::VelocityInterpolation();
+	return TetraRef::VelocityInterpolation(this->element_type);
 }
 /*}}}*/
@@ -892,9 +982,9 @@
 /*}}}*/
 int      Tetra::PressureInterpolation(void){/*{{{*/
-	return TetraRef::PressureInterpolation();
+	return TetraRef::PressureInterpolation(this->element_type);
 }
 /*}}}*/
 int      Tetra::TensorInterpolation(void){/*{{{*/
-	return TetraRef::TensorInterpolation();
+	return TetraRef::TensorInterpolation(this->element_type);
 }
 /*}}}*/
Index: issm/trunk/src/c/classes/Elements/Tetra.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Tetra.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Tetra.h	(revision 18301)
@@ -55,10 +55,9 @@
 		void        ComputeBasalStress(Vector<IssmDouble>* sigma_b){_error_("not implemented yet");};
 		void        ComputeSigmaNN(){_error_("not implemented yet");};
-		void        ComputeStrainRate(){_error_("not implemented yet");};
-		void        ComputeStrainRate(Vector<IssmDouble>* eps){_error_("not implemented yet");};
 		void        ComputeStressTensor(){_error_("not implemented yet");};
 		void        ComputeDeviatoricStressTensor(){_error_("not implemented yet");};
 		void        Configure(Elements* elements,Loads* loads,Nodes* nodesin,Vertices* verticesin,Materials* materials,Parameters* parameters);
 		void        SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Materials* materials,Parameters* parameters);
+		void        ResetHooks();
 		void        Delta18oParameterization(void){_error_("not implemented yet");};
 		void        ElementSizes(IssmDouble* hx,IssmDouble* hy,IssmDouble* hz);
@@ -72,4 +71,5 @@
 		int         GetNodeIndex(Node* node);
 		int         GetNumberOfNodes(void);
+		int         GetNumberOfNodes(int enum_type){_error_("not implemented yet");};
 		int         GetNumberOfVertices(void);
 		void        GetVerticesCoordinatesBase(IssmDouble** pxyz_list);
@@ -88,4 +88,5 @@
 		void        NodalFunctions(IssmDouble* basis,Gauss* gauss);
 		void        NodalFunctionsP1(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
+		void        NodalFunctionsP2(IssmDouble* basis,Gauss* gauss){_error_("not implemented yet");};
 		void        NodalFunctionsVelocity(IssmDouble* basis,Gauss* gauss);
 		void        NodalFunctionsPressure(IssmDouble* basis,Gauss* gauss);
@@ -105,5 +106,5 @@
 		IssmDouble  StabilizationParameter(IssmDouble u, IssmDouble v, IssmDouble w, IssmDouble diameter, IssmDouble kappa){_error_("not implemented yet");};
 		int         PressureInterpolation(void);
-		void        ValueP1OnGauss(IssmDouble* pvalue,IssmDouble* values,Gauss* gauss){_error_("not implemented yet");};
+		void        ValueP1OnGauss(IssmDouble* pvalue,IssmDouble* values,Gauss* gauss);
 		void        ValueP1DerivativesOnGauss(IssmDouble* dvalue,IssmDouble* values,IssmDouble* xyz_list,Gauss* gauss){_error_("not implemented yet");};
 		int         VelocityInterpolation(void);
@@ -127,7 +128,8 @@
 		bool        IsZeroLevelset(int levelset_enum){_error_("not implemented");};
 		bool		   IsIcefront(void);
-		bool   IsFaceOnBoundary(void){_error_("not implemented yet");};
+		bool        IsFaceOnBoundary(void){_error_("not implemented yet");};
 		void        ZeroLevelsetCoordinates(IssmDouble** pxyz_zero,IssmDouble* xyz_list,int levelsetenum);
 		void		   GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum){_error_("not implemented yet");};
+		void		   GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level){_error_("not implemented yet");};
 		void        GetSolutionFromInputsOneDof(Vector<IssmDouble>* solution,int enum_type){_error_("not implemented yet");};
 		void        InputDepthAverageAtBase(int enum_type,int average_enum_type){_error_("not implemented yet");};
@@ -140,5 +142,4 @@
 		void        ReduceMatrices(ElementMatrix* Ke,ElementVector* pe);
 		void        SetTemporaryElementType(int element_type_in){_error_("not implemented yet");};
-		void	      SmbGradients(){_error_("not implemented yet");};
 		IssmDouble  SurfaceArea(void){_error_("not implemented yet");};
 		void        Update(int index, IoModel* iomodel,int analysis_counter,int analysis_type,int finitelement);
@@ -151,18 +152,7 @@
 		IssmDouble IceVolumeAboveFloatation(void){_error_("not implemented yet");};
 		IssmDouble TotalSmb(void){_error_("not implemented yet");};
-		void       MinVel(IssmDouble* pminvel){_error_("not implemented yet");};
-		void       MinVx(IssmDouble* pminvx){_error_("not implemented yet");};
-		void       MinVy(IssmDouble* pminvy){_error_("not implemented yet");};
-		void       MinVz(IssmDouble* pminvz){_error_("not implemented yet");};
 		IssmDouble MassFlux(IssmDouble* segment){_error_("not implemented yet");};
 		IssmDouble MassFlux(IssmDouble x1,IssmDouble y1, IssmDouble x2, IssmDouble y2,int segment_id){_error_("not implemented yet");}
-		void       MaxAbsVx(IssmDouble* pmaxabsvx){_error_("not implemented yet");};
-		void       MaxAbsVy(IssmDouble* pmaxabsvy){_error_("not implemented yet");};
-		void       MaxAbsVz(IssmDouble* pmaxabsvz){_error_("not implemented yet");};
 		void       ElementResponse(IssmDouble* presponse,int response_enum){_error_("not implemented yet");};
-		void       MaxVel(IssmDouble* pmaxvel){_error_("not implemented yet");};
-		void       MaxVx(IssmDouble* pmaxvx){_error_("not implemented yet");};
-		void       MaxVy(IssmDouble* pmaxvy){_error_("not implemented yet");};
-		void       MaxVz(IssmDouble* pmaxvz){_error_("not implemented yet");};
 		IssmDouble Misfit(int modelenum,int observationenum,int weightsenum){_error_("not implemented yet");};
 		IssmDouble MisfitArea(int weightsenum){_error_("not implemented yet");};
@@ -174,20 +164,6 @@
 		IssmDouble DragCoefficientAbsGradient(void){_error_("not implemented yet");};
 		void       GradientIndexing(int* indexing,int control_index){_error_("not implemented yet");};
-		void       Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index){_error_("not implemented yet");};
-		void       GradjBGradient(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDGradient(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjBSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDragSSA(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDragFS(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDragGradient(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjDhDtBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjVxBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjVyBalancedthickness(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
-		void       GradjThicknessBalancethicknessSoft(Vector<IssmDouble>* gradient,int control_index){_error_("not implemented yet");};
 		void       GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data){_error_("not implemented yet");};
 		void       SetControlInputsFromVector(IssmDouble* vector,int control_enum,int control_index){_error_("not implemented yet");};
-		void       ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){_error_("not implemented yet");};
-		void       ControlInputScaleGradient(int enum_type,IssmDouble scale){_error_("not implemented yet");};
 		void       ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){_error_("not implemented yet");};
 		void       ControlToVectors(Vector<IssmPDouble>* vector_control, Vector<IssmPDouble>* vector_gradient,int control_enum){_error_("not implemented yet");};
